#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define viii vector<vii>
#define endl '\n'
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

bool prime(ll n) {
    if (n == 0) return false;
    for (ll i = 2; i * i <= n; i++) {
        if (n % i == 0) {
            return false;
        }
    }
    return true;
}

ll f(string s) {
    ll n = s.size();
    viii dp(n + 1, vii(2, vi(2)));
    dp[0][1][0] = 1;
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= 9; j++) {
            if (j == 1) {
                if (j < s[i - 1] - '0') {
                    dp[i][0][1] += dp[i - 1][1][1] + dp[i - 1][0][1];
                    dp[i][0][0] += dp[i - 1][1][0] + dp[i - 1][0][0];
                } else if (j == s[i - 1] - '0') {
                    dp[i][0][1] += dp[i - 1][0][1];
                    dp[i][1][1] += dp[i - 1][1][1];
                    dp[i][0][0] += dp[i - 1][0][0];
                    dp[i][1][0] += dp[i - 1][1][0];
                }
                continue;
            }
            if (prime(j)) {
                if (j < s[i - 1] - '0') {
                    dp[i][0][1] += dp[i - 1][1][0] + dp[i - 1][0][0];
                } else if (j == s[i - 1] - '0') {
                    dp[i][0][1] += dp[i - 1][0][0];
                    dp[i][1][1] += dp[i - 1][1][0];
                } else {
                    dp[i][0][1] += dp[i - 1][0][0];
                }
            }
        }
    }
    ll ans = 0;
    for (ll i = 0; i < 2; i++) {
        for (ll j = 0; j < 2; j++) {
            ans += dp[n][i][j];
        }
    }
    for (ll i = 1; i < n; i++) {
        ans += 4 * i;
    }
    return ans - (s != "0");
}

bool is(string s) {
    for (char e: s) {
        ll j = e - '0';
        if (!prime(j)) {
            return false;
        }
    }
    return true;
}

void solve() {
    string l, r;
    cin >> l >> r;
    cout << f(r) - f(l) + is(l);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
