#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define endl '\n'
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using oset = tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update>;

struct DSU {
    vi s, p, l, r;

    DSU(ll n, vi &a) {
        p.resize(n);
        s.resize(n, 1);
        iota(all(p), 0);
        l.resize(n);
        r.resize(n);
        for (ll i = 0; i < n; i++) {
            l[i] = r[i] = a[i];
        }
    }

    ll leader(ll v) {
        if (v == p[v]) return v;
        return p[v] = leader(p[v]);
    }

    void unite(ll x, ll y) {
        x = leader(x);
        y = leader(y);
        if (x == y) return;
        ll fl = 0;
        if (s[y] > s[x]) {
            fl = 1;
            swap(x, y);
        }
        p[y] = x;
        s[x] += s[y];
        if (fl == 0) {
            r[x] = r[y];
        } else {
            l[x] = l[y];
        }
    }
};

void solve() {
    ll n;
    cin >> n;
    vi a(n), left(n), rig(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        left[i] = a[i];
        rig[i] = a[i];
    }
    vi k(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    if (n <= 1000) {
        vi b(n);
        iota(all(b), 0);
        for (ll i = 0; i < n - 1; i++) {
            ll num = k[i] - 1;
            ll l, r;
            for (ll j = 0; j < n; j++) {
                if (num == b[j]) {
                    l = j;
                    break;
                }
            }
            for (ll j = 0; j < n; j++) {
                if (num + 1 == b[j]) {
                    r = j;
                }
            }
            ll val1 = 0;
            for (ll j = l; j <= r; j++) {
                val1 += min(left[j], rig[j]) - a[j];
            }
            for (ll j = l + 1; j <= r; j++) {
                b[j] = num;
                left[j] = max(left[j - 1], left[j]);
            }
            for (ll j = r - 1; j >= l; j--) {
                rig[j] = max(rig[j], rig[j + 1]);
            }
            for (ll j = r + 1; j < n; j++) {
                b[j]--;
            }
            ll val2 = 0;
            for (ll j = l; j <= r; j++) {
                val2 += min(left[j], rig[j]) - a[j];
            }
            cout << val2 << endl;
        }
    } else {
        vi pref(n + 1);
        for (ll i = 1; i <= n; i++) {
            pref[i] = pref[i - 1] + a[i - 1];
        }
        ll mn_id = 0;
        for (ll i = 0; i < n; i++) {
            if (a[i] < a[mn_id]) {
                mn_id = i;
            }
        }
        DSU dsu(n, a);
        oset s;
        for (ll i = 0; i < n - 1; i++) {
            ll num = k[i] - 1;
            ll l = 0, r = n;
            while (r - l > 1) {
                ll mid = (l + r) / 2;
                if (mid - s.order_of_key(mid) <= num) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            ll id = l;
            ll j = id + 1;
            l = id - dsu.s[dsu.leader(id)] + 1;
            r = id + dsu.s[dsu.leader(id + 1)];
            dsu.unite(id, j);
            ll lead = dsu.leader(id);
            ll v1 = dsu.l[lead], v2 = dsu.r[lead];
            ll val = min(v1, v2);
            if (mn_id >= l && mn_id <= r) {
                ll L1 = l - 1, R1 = mn_id;
                while (R1 - L1 > 1) {
                    ll mid = (L1 + R1) / 2;
                    if (a[mid] <= val)
                        R1 = mid;
                    else
                        L1 = mid;
                }
                l = R1;
                L1 = mn_id, R1 = r + 1;
                while (R1 - L1 > 1) {
                    ll mid = (L1 + R1) / 2;
                    if (a[mid] <= val)
                        L1 = mid;
                    else
                        R1 = mid;
                }
                r = L1;
                cout << val * (r - l + 1) - (pref[r + 1] - pref[l]) << endl;
            } else {
                cout << 0 << endl;
            }
            s.insert(id);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
